package vishnu.testvis.sammon;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import vishnu.testvis.visual.*;
import vishnu.testvis.object.*;
import java.util.*;
import vishnu.testvis.treemap.table.*;

class SammKeywordPanel extends JPanel
{
    RW_DataModel _dataModel;
    //SammRWTable _dataModel;
    JTable _table = new JTable();
    JScrollPane theScrollPane;
    JCheckBox checkBoxes[];
    JLabel labels[];
    Vishnu currentMain;
    GraphicalPane parentPane;

    public SammKeywordPanel(Vishnu currentMain, GraphicalPane parent)
    {
        this.currentMain = currentMain;
        this.parentPane = parent;
        
        theScrollPane = new JScrollPane();

         //setBackground(Color.white);
        setPreferredSize(new Dimension(200,900));
        setBorder(BorderFactory.createLoweredBevelBorder());
        setLayout(new BorderLayout(10,0));
        Font theFont = new java.awt.Font("Monospaced", 0, 12);

        //JLabel title = new JLabel("Related keywords");
        //title.setFont(theFont);
        //add(title,"North");

        _dataModel = new RW_DataModel();
        //_dataModel = new SammRWTable();
        _table.setModel(_dataModel);

        _table.setAutoCreateColumnsFromModel(false);
        _table.getColumnModel().getColumn(0).setPreferredWidth(20);
        _table.getColumnModel().getColumn(1).setPreferredWidth(100);
        _table.getColumnModel().getColumn(2).setPreferredWidth(50);
        _table.setRowSelectionAllowed(false);
        setupRenderer();

        theScrollPane.getViewport().add(_table, null);
        add(theScrollPane,"Center");

        setVisible(true);

        JButton refineButton = new JButton("Filter Documents");
        refineButton.setBorder(BorderFactory.createRaisedBevelBorder());
        refineButton.setMaximumSize(new Dimension(30,70));

        MouseListener ml = new MouseAdapter()
        {
            public void mouseClicked(MouseEvent e)
            {
                // what does this do Shalini?
                // Call the refine engine
                refineEngine();
            }
        };

        refineButton.addMouseListener(ml);
        refineButton.setFont(theFont);
        add(refineButton,"South");


    }
    public void refineEngine()
    {
       currentMain.log.startsection("FILTERING");
       
       parentPane.hLinkPanel.setText(_dataModel.getRefinedDocs());
       String trec_id[] = _dataModel.getRefinedTrecIDs();
       String filter_Words[] = _dataModel.getFilterWords();
       String s = new String("");
       for( int i = 0; i < filter_Words.length; i++ )
       {
            s += filter_Words[i] + " ";
       }
      
       currentMain.log.log("FILTER_WORDS",s);
       currentMain.log.log("FILTERED_DOCS",Integer.toString(trec_id.length));
       
       Vector performance = currentMain.queries.getPerformance(currentMain.query, trec_id);
       
       currentMain.log.startsection("PERFORMANCE");

       if( performance.size() > 0 )
       {
            Integer relvTotal = (Integer)performance.elementAt(performance.size()-2);
            Integer relvRetr = (Integer)performance.elementAt(performance.size()-1);
            currentMain.log.log("RELEVANT_TOTAL",Integer.toString(relvTotal.intValue()));
            currentMain.log.log("RELEVANT_RETRIEVED",Integer.toString(relvRetr.intValue()));
            for( int i = 0; i < performance.size()-2; i++ )
            {
                Integer perf = (Integer)performance.elementAt(i);
                String str = "PRECISION_" + Integer.toString((i+1)*10);
                currentMain.log.log(str,Integer.toString(perf.intValue()));
            }
       }
       else
       {
            currentMain.log.log("INFO","No relevance data available");
       }
     
                   
       currentMain.log.endsection("PERFORMANCE");
       currentMain.log.endsection("FILTERING");
    }
        
    // have dendroclusterobj/sammonclusterobj etc as subclasses
    // of some abstract clusterObj superclass with some 
    // core fields (docs, hitdocFreq etc)
    public void update(ClusterObj c)
    {
        _dataModel.setData(currentMain.dataManager.getWords(), c);
    }
    
    public void update2(vishnu.testvis.dendro.ClusterObj c)
    {
        _dataModel.setData(currentMain.dataManager.getWords(), c);
    }

    public void clear()
    {
        _dataModel.clear();
    }
    private void setupRenderer()
    {
        BarRenderer bar = new BarRenderer();
        //-- Have a number painted in the middle of the bar
        bar.setStringPainted(true);
        //-- setup the background color of the bar
        bar.setBackground(_table.getBackground());

        //-- render the last column as a bar
        _table.getColumnModel().getColumn(2).setCellRenderer(bar);
    }


}
